    // Declare Variables
    var oPageStyleClass;
    var oLorStyleClass;
    var oHeaderStyleClass;
    var oFooterStyleClass;
    var oMMarkerClass;
    var fZoomNum = 1;
    var PrintQuality = "QNormal";
    var SrcDoc;
    var selectionDoc;
    var orignalDoc;
    var activeFrameDoc;
    var allFrames = new Array();
    var CurrentFrameIndex;
    var TotalFrames;

//**********************************************
// FUNCTION : FindStyleRule
// A function to grab page elements as JS objects
//**********************************************
    function FindStyleRule(styleName) {
      for (i = 0; i < document.styleSheets.length; i++) {
        for (j = 0; j < document.styleSheets(i).rules.length; j++) {
          if (document.styleSheets(i).rules(j).selectorText == styleName) return document.styleSheets(i).rules(j);
        }
      }
    }

//**********************************************
// FUNCTION : InitClasses
// Set all page elements to have the dimensions of a physical page
//**********************************************
    function InitClasses() {
      oLorStyleClass.style.marginTop = printer.marginTop/100 + "in";
      oLorStyleClass.style.marginLeft = printer.marginLeft/100 + "in";

      if (myOrientation == "portrait") {
        oPageStyleClass.style.width = "" + PageWidth + "in";
        oPageStyleClass.style.height = "" + PageHeight + "in";
        oLorStyleClass.style.width = PageWidth - (printer.marginLeft/100 + (PageWidth - printer.marginRight/100)) + "in";
        oLorStyleClass.style.height = PageHeight - (printer.marginTop/100 + (PageHeight - printer.marginBottom/100)) + "in";
      } else {
        oPageStyleClass.style.width = "" + PageHeight + "in";
        oPageStyleClass.style.height = "" + PageWidth + "in";
        oLorStyleClass.style.width = PageHeight - (printer.marginLeft/100 + (PageHeight - printer.marginRight/100)) + "in";
        oLorStyleClass.style.height = PageWidth - (printer.marginTop/100 + (PageWidth - printer.marginBottom/100)) + "in";
      }

      oHeaderStyleClass.style.left = printer.marginLeft/100 + "in";
      oHeaderStyleClass.style.top = printer.unprintableTop/100 + "in";
      oHeaderStyleClass.style.width = oLorStyleClass.style.width;
      oFooterStyleClass.style.left = printer.marginLeft/100 + "in";
      oFooterStyleClass.style.width = oLorStyleClass.style.width;
      oFooterStyleClass.style.top = null;
      oFooterStyleClass.style.bottom = printer.unprintableBottom/100 + "in";
    }

//**********************************************
// FUNCTION : Init
// Initialisation
//**********************************************
    function Init() {
      // Attach event handlers for mouse
      document.attachEvent("onmousedown", MouseDownHandler);
      document.attachEvent("onmouseup", MouseUpHandler);
      document.attachEvent("onmousemove", MouseMoveHandler);

      // These were in the original MS example, but seemed unecessary.
      //   No problems so far, but uncomment if problems occur
//      mmarkerLeft.attachEvent("onmousemove", MouseMoveHandler);
//      mmarkerRight.attachEvent("onmousemove", MouseMoveHandler);
//      mmarkerTop.attachEvent("onmousemove", MouseMoveHandler);

      // Prepare the preview document
      AddFirstPage();

      // Initial Zoom
      zoomcontainer.style.zoom = "80%";

      // User Interface
      uiLeft.style.width = 235;
      uiLeft.style.height = document.body.clientHeight;
      uiTop.style.width = document.body.clientWidth - 235;
      uiTop.style.height = "50px";

      // Grey area behind document
      pagecontainer.style.width = document.body.clientWidth - uiLeft.style.pixelWidth;
      pagecontainer.style.height = document.body.clientHeight - uiTop.style.pixelHeight;

      // Grab 'style' object for document so they can be manipulated as necessary
      oPageStyleClass = FindStyleRule(".pagestyle");
      oLorStyleClass = FindStyleRule(".lorstyle");
      oHeaderStyleClass = FindStyleRule(".headerstyle");
      oFooterStyleClass = FindStyleRule(".footerstyle");
      oMMarkerClass = FindStyleRule(".mmarker");

      // Grab object of all HTML in document
      SrcDoc = layoutrect1.contentDocument;
      // Save reference to 'document' of user's selection
      selectionDoc = dialogArguments.__IE_ContentSelectionUrl;
      // Save reference to original document
      originalDoc = dialogArguments.__IE_ContentDocumentUrl;

      // Small delay here resolved some issues with frames
      setTimeout("FinishInit()",30);
    }

//**********************************************
// FUNCTION : FinishInit
// Initialise frames
//**********************************************
    function FinishInit() {
      // Check from FRAME tags in documents source
      if (SrcDoc.all.tags("FRAME").length != 0) {
        // Count them
        TotalFrames = SrcDoc.all.tags("FRAME").length;
        // Remember the frame number of the active frame
        activeFrameIndex = layoutrect1.contentDocument.all.tags("HTML")[0].__IE_ActiveFrame;
        // Get all frames
        activeFrameTemp = SrcDoc.all.tags("FRAME");
        // If there was an active frame...
        if (activeFrameIndex) {
          // Save a reference to the active frame
          activeFrameDoc = activeFrameTemp[activeFrameIndex].src;
          // Set it as the default option in settings
          printer.frameActive = true;
          printer.frameAsShown = false;
          printer.framesetDocument = false;
          // Push a reference to all frames into an array
          for (i = 0; i < SrcDoc.all.tags("FRAME").length; i++) {
            allFrames.push(activeFrameTemp[i].src);
          }
          // Load active frame into preview window
          layoutrect1.contentSrc = activeFrameDoc;
          layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;
        // No active frame...
        } else {
          // Load all frames into array
          for (i = 0; i < SrcDoc.all.tags("FRAME").length; i++) {
            allFrames.push(activeFrameTemp[i].src);
          }
          // Check radio button for 'As Laid Out on Screen'
          Frames[0].checked = true;
        }
      // There are no frames...
      } else {
        Frames[0].checked = true;
        TotalFrames = 0;
      }

      // Initialise windows for printing costs
      InitFoldOuts();

      // Margins start hidden
      ShowHideMargins();
      Rest('HSMargin');

      // Page defaults to portrait
      SetOrientation('portrait');
    }

//**********************************************
// FUNCTION : InitMMarkers
// Initialize Margin Markers
//**********************************************
    function InitMMarkers() {
      mmarkerLeft.style.top = oLorStyleClass.style.marginTop;
      mmarkerRight.style.top = oLorStyleClass.style.marginTop;
      mmarkerLeft.style.left = oLorStyleClass.style.marginLeft;
      mmarkerRight.style.left = printer.marginRight/100 + "in";
      mmarkerTop.style.top = oLorStyleClass.style.marginTop;
      mmarkerBottom.style.top = printer.marginBottom/100 + "in";
      mmarkerTop.style.left = oLorStyleClass.style.marginLeft;
      mmarkerBottom.style.left = oLorStyleClass.style.marginLeft;

      mmarkerLeft.style.pixelTop -= 2;
      mmarkerLeft.style.pixelLeft += 6;
      mmarkerRight.style.pixelTop -= 2;
      mmarkerRight.style.pixelLeft += 5;
      mmarkerTop.style.pixelTop += 6;
      mmarkerTop.style.pixelLeft -= 2;
      mmarkerBottom.style.pixelTop += 5;
      mmarkerBottom.style.pixelLeft -= 2;
    }

//**********************************************
// FUNCTION : InitTotals
// Calculate and display all of the values in the printing fold-out
//**********************************************
    function InitTotals() {
      // If only printing a selection of pages
      if (printer.selectedPages == true) {
        myTotalPages = printer.pageTo - printer.pageFrom + 1;
      }

      // Get objects for all relevant HTML code
      BWCosts = document.all("BWCostPerPage");
      BWNoCopies = document.all("BWNumCopies");
      BWTotalPages = document.all("BWTotPages");
      BWTotalCost = document.all("BWTotCost");
      ColourCosts = document.all("ColourCostPerPage");
      ColourNoCopies = document.all("ColourNumCopies");
      ColourTotalPages = document.all("ColourTotPages");
      ColourTotalCost = document.all("ColourTotCost");
      PageCount = document.all("TotPages");

      // Cost of Copies
      BWCosts.innerHTML = BWCostString;
      ColourCosts.innerHTML = ColourCostString;
      // Number of copies
      BWNoCopies.innerHTML = NumCopies;
      ColourNoCopies.innerHTML = NumCopies;
      // Total printed pages
      BWTotalPages.innerHTML = myTotalPages * NumCopies;
      ColourTotalPages.innerHTML = myTotalPages * NumCopies;
      // Total Cost
      BWTotalCost.innerHTML = "$" + (myTotalPages * NumCopies * BWCost).toFixed(2);
      ColourTotalCost.innerHTML = "$" + (myTotalPages * NumCopies  * ColourCost).toFixed(2);
      // Change at the top of the page
      PageCount.innerHTML = myTotalPages;
    }

//**********************************************
// FUNCTION : InitFoldOuts
// Get objects for each of the fold-out areas
//**********************************************
    function InitFoldOuts() {
      BWArea = document.all("BWFoldOut").style;
      ColourArea = document.all("ColourFoldOut").style;
      BWArea.clip = "rect(0 250 250 0)";
      ColourArea.clip = "rect(0 250 250 0)";
      SettingsA = document.all("SettingsArea").style;
      SettingsB = document.all("SettingsButton").style;
    }

