    var iStartingX;
    var iStartingY;
    var bMoveMMarkerLeft = false;
    var bMoveMMarkerRight = false;
    var bMoveMMarkerTop = false;
    var bMoveMMarkerBottom = false;
    var iDeltaX = 0;
    var iDeltaY = 0;
    var iPixelToInchRatio;
    var oPopup;
    var oPopupBody;
    var sSrcID = null

//**********************************************
// FUNCTION : MouseDownHandler
// Handles mouse clicks on margin sliders
//**********************************************
    function MouseDownHandler() {
      // Test for left click only
      if (event.button != 1) return;

      // Zoom settings will effect measurements. Check zoom
      sZoomNum = zoomcontainer.style.zoom;
      sZoomNum = sZoomNum.substring(0, sZoomNum.length - 1);
      iZoomNum = sZoomNum.valueOf(sZoomNum, 10);
      fZoomNum = iZoomNum/100

      // What margin was clicked on
      sSrcID = event.srcElement.id;

      // Multiplier for on-screen display. Set during initialisation
      iPixelToInchRatio = ratiomarker.offsetLeft;

      // Left Margin
      if (sSrcID == "mmarkerLeft") {
        bMoveMMarkerLeft = true;
        // X co-ord of click
        iStartingX = event.x;
        // Difference between x co-ord of click and margin graphic
        iDeltaX = (mmarkerLeft.offsetLeft - event.x);
        iDeltaY = 0;

        // Open tiny window to display measurement
        oPopup = window.createPopup();
        oPopupBody = oPopup.document.body;
        theText = Math.round((100 * (mmarkerLeft.offsetLeft - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";
        oPopupBody.style.backgroundColor = "#ffff66";
        oPopupBody.style.border = "1 solid black";
        oPopupBody.style.fontSize = "12px";
        oPopupBody.style.fontFamily = "Courier New";
        oPopup.show(fZoomNum * (mmarkerLeft.offsetLeft + 5), fZoomNum * (mmarkerLeft.offsetTop - 20), 60, 16, zoomcontainer);

        return;
      }

      // Right Margin
      if (sSrcID == "mmarkerRight") {
        bMoveMMarkerRight = true;
        // X co-ord of click
        iStartingX = event.x;
        // Difference between x co-ord of click and margin graphic
        iDeltaX = (mmarkerRight.offsetLeft - event.x);
        iDeltaY = 0;

        // Open tiny window to display measurement
        oPopup = window.createPopup();
        oPopupBody = oPopup.document.body;
        theText = Math.round((100 * (mmarkerRight.offsetLeft - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";
        oPopupBody.style.backgroundColor = "#ffff66";
        oPopupBody.style.border = "1 solid black";
        oPopupBody.style.fontSize = "12px";
        oPopupBody.style.fontFamily = "Courier New";
        oPopup.show(fZoomNum * (mmarkerRight.offsetLeft + 5) - 60, fZoomNum * (mmarkerRight.offsetTop - 20), 60, 16, zoomcontainer);

        return;
      }

      // Top Margin
      if (sSrcID == "mmarkerTop") {
        bMoveMMarkerTop = true;
        // Y co-ord of click
        iStartingY = event.y;
        iDeltaX = 0;
        // Difference between Y co-ord of click and margin graphic
        iDeltaY = (mmarkerTop.offsetTop - event.y);

        // Open tiny window to display measurement
        oPopup = window.createPopup();
        oPopupBody = oPopup.document.body;
        theText = Math.round((100 * (mmarkerLeft.offsetTop - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";
        oPopupBody.style.backgroundColor = "#ffff66";
        oPopupBody.style.border = "1 solid black";
        oPopupBody.style.fontSize = "12px";
        oPopupBody.style.fontFamily = "Courier New";
        oPopup.show(fZoomNum * (mmarkerTop.offsetLeft + 5) - 70, fZoomNum * (mmarkerTop.offsetTop + 5), 60, 16, zoomcontainer);

        return;
      }

      // Bottom Margin
      if (sSrcID == "mmarkerBottom") {
        bMoveMMarkerBottom = true;
        // Y co-ord of click
        iStartingY = event.y;
        iDeltaX = 0;
        // Difference between Y co-ord of click and margin graphic
        iDeltaY = (mmarkerBottom.offsetTop - event.y);

        // Open tiny window to display measurement
        oPopup = window.createPopup();
        oPopupBody = oPopup.document.body;
        theText = Math.round((100 * (mmarkerBottom.offsetTop - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";
        oPopupBody.style.backgroundColor = "#ffff66";
        oPopupBody.style.border = "1 solid black";
        oPopupBody.style.fontSize = "12px";
        oPopupBody.style.fontFamily = "Courier New";
        oPopup.show(fZoomNum * (mmarkerTop.offsetLeft + 5) - 70, fZoomNum * (mmarkerBottom.offsetTop) - 10, 60, 16, zoomcontainer);

        return;
      }

      sSrcID = null;
    }

//**********************************************
// FUNCTION : MouseMoveHandler
// Function to handle the movement of the margins
//**********************************************
    function MouseMoveHandler() {
      // Get ratio for on-screen display
      iPixelToInchRatio = ratiomarker.offsetLeft;
      // Find position reletive to starting position. Don't forget to compensate for zoom
      fZoomCompensationX = (event.x - iStartingX)*(1/fZoomNum - 1);
      fZoomCompensationY = (event.y - iStartingY)*(1/fZoomNum - 1);

      // Moving left margin
      if (bMoveMMarkerLeft) {
        // Stop moving if less than 0.5" or greater than 4.0"
        if (event.x + iDeltaX + fZoomCompensationX < iPixelToInchRatio * DefaultSideMargins && myOrientation == "portrait") return false;
        if (event.x + iDeltaX + fZoomCompensationX > iPixelToInchRatio * LimitSideMargins && myOrientation == "portrait") return false;
        if (event.x + iDeltaX + fZoomCompensationX < iPixelToInchRatio * DefaultBottomMargin && myOrientation == "landscape") return false;
        if (event.x + iDeltaX + fZoomCompensationX > iPixelToInchRatio * LimitBottomMargin && myOrientation == "landscape") return false;
        // Move picture
        mmarkerLeft.style.left = event.x + iDeltaX + fZoomCompensationX;
        // Update text in popup window
        theText = Math.round((100 * (mmarkerLeft.offsetLeft - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";

      // Moving Right margin
      } else if (bMoveMMarkerRight) {
        // Stop moving if less than 0.5" or greater than 4.0" from right edge. Various depending on orientation
        if (event.x + iDeltaX + fZoomCompensationX < iPixelToInchRatio * (PageWidth - DefaultSideMargins) && myOrientation == "portrait") return false;
        if (event.x + iDeltaX + fZoomCompensationX > iPixelToInchRatio * (PageWidth - LimitSideMargins) && myOrientation == "portrait") return false;
        if (event.x + iDeltaX + fZoomCompensationX < iPixelToInchRatio * (PageHeight - DefaultTopMargin) && myOrientation == "landscape") return false;
        if (event.x + iDeltaX + fZoomCompensationX > iPixelToInchRatio * (PageHeight - LimitTopMargin) && myOrientation == "landscape") return false;
        // Move picture
        mmarkerRight.style.pixelLeft = event.x + iDeltaX + fZoomCompensationX;
        // Update text in popup window
        theText = Math.round((printer.pageWidth - (100 * (mmarkerRight.offsetLeft - 5))/iPixelToInchRatio))/100;
        oPopupBody.innerHTML = theText + " in";

      // Moving Top margin
      } else if (bMoveMMarkerTop) {
        // Stop moving if less than 0.5" or greater than 2.0" from top edge
        if (event.y + iDeltaY + fZoomCompensationY < iPixelToInchRatio * DefaultTopMargin && myOrientation == "portrait") return false;
        if (event.y + iDeltaY + fZoomCompensationY > iPixelToInchRatio * LimitTopMargin && myOrientation == "portrait") return false;
        if (event.y + iDeltaY + fZoomCompensationY < iPixelToInchRatio * DefaultSideMargins && myOrientation == "landscape") return false;
        if (event.y + iDeltaY + fZoomCompensationY > iPixelToInchRatio * LimitSideMargins && myOrientation == "landscape") return false;
        // Move picture
        mmarkerTop.style.pixelTop = event.y + iDeltaY + fZoomCompensationY;
        // Update text in popup window
        theText = Math.round((100 * (mmarkerTop.offsetTop - 5))/iPixelToInchRatio)/100;
        oPopupBody.innerHTML = theText + " in";

      // Moving Bottom margin
      } else if (bMoveMMarkerBottom) {
        // Stop moving if less than 0.5" or greater than 2.0" from bottom edge. Various depending on orientation
        if (event.y + iDeltaY + fZoomCompensationY < iPixelToInchRatio * (PageHeight - DefaultBottomMargin) && myOrientation == "portrait") return false;
        if (event.y + iDeltaY + fZoomCompensationY > iPixelToInchRatio * (PageHeight - LimitBottomMargin) && myOrientation == "portrait") return false;
        if (event.y + iDeltaY + fZoomCompensationY < iPixelToInchRatio * (PageWidth - DefaultSideMargins) && myOrientation == "landscape") return false;
        if (event.y + iDeltaY + fZoomCompensationY > iPixelToInchRatio * (PageWidth - LimitSideMargins) && myOrientation == "landscape") return false;
        // Move picture
        mmarkerBottom.style.pixelTop = event.y + iDeltaY + fZoomCompensationY;
        // Update text in popup window
        theText = Math.round((printer.pageHeight - (100 * (mmarkerBottom.offsetTop - 5))/iPixelToInchRatio))/100;
        oPopupBody.innerHTML = theText + " in";
      }

      return false;
    }

//**********************************************
// FUNCTION : MouseUpHandler
// Function to handle the release of the mouse button and reset margins
//**********************************************
    function MouseUpHandler() {
      // Check variable set when mouse pressed
      if (!sSrcID) return;

      // Get ratio for on-screen display
      iPixelToInchRatio = ratiomarker.offsetLeft;

      switch (sSrcID) {
        // Left Margin
        case "mmarkerLeft":
          // Set the margin
          printer.marginLeft = 100 * (mmarkerLeft.offsetLeft - 5)/iPixelToInchRatio;
          // Hide the measurement window
          oPopup.hide();
          break;

        // Right Margin
        case "mmarkerRight":
          // Set the margin
          printer.marginRight = 100 * (mmarkerRight.offsetLeft - 5)/iPixelToInchRatio;
          // Hide the measurement window
          oPopup.hide();
          break;

        // Top Margin
        case "mmarkerTop":
          // Set the margin
          printer.marginTop = 100 * (mmarkerTop.offsetTop - 5)/iPixelToInchRatio;
          // Hide the measurement window
          oPopup.hide();
          break;

        // Bottom Margin
        case "mmarkerBottom":
          // Set the margin
          printer.marginBottom = 100 * (mmarkerBottom.offsetTop - 5)/iPixelToInchRatio;
          // Hide the measurement window
          oPopup.hide();
          break;
      }

      // Redo pagination
      InitClasses();
      InitMMarkers();

      layoutrect1.contentSrc = layoutrect1.contentSrc;
      layoutrect1.contentDocument.onreadystatechange = DocumentCompleteCallback;

      // Reset all variables used
      iDeltaX = 0;
      iDeltaY = 0;
      bMoveMMarkerLeft = false;
      bMoveMMarkerRight = false;
      bMoveMMarkerTop = false;
      bMoveMMarkerBottom = false;
      sSrcID = null;
    }

//**********************************************
// FUNCTION : ShowHideMargins
// Turns on and off the display of margins and margin markers
//**********************************************
    function ShowHideMargins() {
      if (MarginsVis) {
        oMMarkerClass.style.display = "none";
        oLorStyleClass.style.border = "dashed 1 white";
        document["HSMargin"].src = "images/ShowMarginDownButton.jpg";
        MarginsVis = 0;
      } else {
        oMMarkerClass.style.display = "block";
        oLorStyleClass.style.border = "dashed 1 black";
        document["HSMargin"].src = "images/HideMarginDownButton.jpg";
        MarginsVis = 1;
      }
    }

//**********************************************
// FUNCTION : ResetMargins
// Reset margins to default values, also used when changing page orientation
//**********************************************
    function ResetMargins() {
      iPixelToInchRatio = ratiomarker.offsetLeft;

      if (myOrientation == "portrait") {
        mmarkerLeft.style.Left = iPixelToInchRatio * DefaultSideMargins;
        printer.marginLeft = (100 * (mmarkerLeft.style.Left - 5) / iPixelToInchRatio);
        mmarkerRight.style.Left = iPixelToInchRatio * (PageWidth - DefaultSideMargins);
        printer.marginRight = (100 * (mmarkerRight.style.Left - 5) / iPixelToInchRatio);
        mmarkerTop.style.Top = iPixelToInchRatio * DefaultTopMargin;
        printer.marginTop = 100 * (mmarkerTop.style.Top - 5) / iPixelToInchRatio;
        mmarkerBottom.style.Top = iPixelToInchRatio * (PageHeight - DefaultBottomMargin);
        printer.marginBottom = (100 * (mmarkerBottom.style.Top - 5) / iPixelToInchRatio);

      // Remember that landscape settings are all turned 90 degrees right so...
      //   Left = Bottom
      //   Top = Left etc.
	    } else {
        mmarkerLeft.style.left = iPixelToInchRatio * DefaultBottomMargin;
        printer.marginLeft = 100 * (mmarkerLeft.style.Left - 5) / iPixelToInchRatio;
        mmarkerRight.style.Left = iPixelToInchRatio * (PageHeight - DefaultTopMargin);
        printer.marginRight = (100 * (mmarkerRight.style.Left - 5) / iPixelToInchRatio);
        mmarkerTop.style.Top = iPixelToInchRatio * DefaultSideMargins;
        printer.marginTop = 100 * (mmarkerTop.style.Top - 5) / iPixelToInchRatio;
        mmarkerBottom.style.Top = iPixelToInchRatio * (PageWidth - DefaultSideMargins);
        printer.marginBottom = (100 * (mmarkerBottom.style.Top - 5) / iPixelToInchRatio);
	    }

      InitClasses();
      InitMMarkers();
    }

